<?php

namespace Intergo\Log\Contracts;

class LoggingFieldsEnum extends AbstractEnumContract
{
    # USER/AUTHENTICATION:
    const A2_CODE                  = 'a2_code';
    const API_ID                   = 'api_id';
    const API_KEY                  = 'api_key';
    const AUTH_RESULT              = "auth_result";
    const AUTH_USER_ID             = "auth_user_id";
    const AUTHENTICATION_ATTEMPTS  = "authentication_attempts";
    const AVATAR                   = "avatar";
    const BAN_REASON               = "ban_reason";
    const BUSINESS_ADDRESS         = "business_address";
    const BUSINESS_CITY            = "business_city";
    const BUSINESS_COUNTRY         = "business_country";
    const BUSINESS_POSTAL_CODE     = "business_postal_code";
    const CALLBACK_URL             = 'callback_url';
    const CLIENT_ID                = 'clientId';
    const COUNTRY                  = "country";
    const COUNTRY_IP               = "country_ip";
    const CONFIRM_CODE             = "confirm_code";
    const EMAIL                    = "email";
    const FAILED_AT                = "failed_at";
    const FAIL_STATUS              = "fail_status";
    const FIRST_NAME               = "first_name";
    const FORM_PARAMS              = "form_params";
    const IP_ADDRESS               = "ip";
    const JWT_AUTH_SECRET          = 'jwt_auth_secret';
    const LAST_NAME                = "last_name";
    const NAME                     = "name";
    const PASSWORD                 = "password";
    const PHONE                    = "phone";
    const REFRESHED_TOKEN          = "refreshed_token";
    const REGISTER_RESULT          = "register_result";
    const REQUEST_IP               = "request_ip";
    const RESPONSE_DATA            = "response_data";
    const RESPONSE_MESSAGE         = "response_message";
    const RESTRICTED_TO_OWN_NUMBER = "restricted_to_own_number"; //@todo: add it to type?
    const RESTORE_HASH             = "restore_hash";
    const RULE                     = "rule";
    const RULE_RESULT              = "rule_result";
    const SECRET                   = 'secret';
    const SEARCH_KEYWORD           = "search_keyword";
    const SENT_AT                  = "sent_at";
    const SERVICE_ID               = "service_id";
    const SERVICE_NAME             = "service_name";
    const SIGNED_PAYLOAD           = "signed_payload";
    const SITE                     = "site";
    const SMS_USER_ID              = "sms_user_id";
    const TEAM_ID                  = "team_id";
    const TITLE                    = "title";
    const TIMEZONE                 = "timezone";
    const TOKEN                    = "token";
    const TWOFA_ATTEMPTS           = 'twofa_attempts';
    const UNVERIFIED_EMAIL         = "unverified_email";
    const UPDATED_BY_AUTH_USER_ID  = "updated_by_auth_user_id";
    const USERNAME                 = "username";
    const DOMAIN                   = "domain";
    const PARAMS                   = "params";

    # LISTS/CONTACTS
    const HAS_USER_LISTS = "has_user_lists";
    const LIST_CONTACTS  = "list_contacts";

    # BALANCE/MONEY:
    const AMOUNT                    = "amount";
    const AMOUNT_IN_EUR             = "amount_in_eur";
    const BALANCE                   = "balance";
    const BILLING_COUNTRY           = "billing_country";
    const BILLING_DETAILS           = "billing_details";
    const COUNT                     = "count";
    const CURRENCY                  = "currency";
    const FORMATTED_TOTAL           = "formatted_total";
    const NEW_BALANCE               = "new_balance";
    const NEW_DB_BALANCE            = "new_db_balance";
    const OLD_BALANCE               = "old_balance";
    const OLD_BALANCE_BEFORE_CHANGE = "old_balance_before_change";
    const OLD_BALANCE_AFTER_CHANGE  = "old_balance_after_change";
    const PAYMENT_ID                = "payment_id";
    const PAYMENT_METHOD            = "payment_method";
    const PAYMENT_METHOD_ID         = "payment_method_id";
    const PROFORMA_INVOICE_NUMBER   = "proforma_invoice_number";
    const REMARKS                   = "remarks";
    const REFUND_DATE               = "refund_date";
    const STATUS                    = "status";
    const TOTAL                     = "total";
    const VAT                       = "vat";
    const VAT_IN_EUR                = "vat_in_eur";
    const GATEWAY_FEE               = "gateway_fee";
    const GATEWAY_FEE_IN_EUR        = "gateway_fee_in_eur";
    const INTERVAL                  = "interval";
    const REFUND_AMOUNT             = "refund_amount";
    const GATEWAY_IDENTIFIER        = "gateway_identifier";
    const PAYOUT_AMOUNT             = "payout_amount";
    const PAYOUT_ID                 = "payout_id";

    # JCC
    const ACQUIRER_ID                = "acquirerID";
    const ACQ_ID                     = "AcqID";
    const CAPTURE_FLAG               = "CaptureFlag";
    const EXPECTED_SIGNATURE         = "expectedSignature";
    const MERCHANT_ID                = "merchantID";
    const MER_ID                     = "MerID";
    const MER_RESP_URL               = "MerRespURL";
    const MER_CALLBACK_URL           = "MerCallbackURL";
    const ORDER_ID                   = "OrderID";
    const PURCHASE_AMT               = "PurchaseAmt";
    const PURCHASE_CURRENCY          = "PurchaseCurrency";
    const PURCHASE_CURRENCY_EXPONENT = "PurchaseCurrencyExponent";
    const REASON_CODE                = "reasonCode";
    const RESPONSE_CODE              = "responseCode";
    const RESPONSE_SIGNATURE         = "responseSignature";
    const SIGNATURE                  = "Signature";
    const SIGNATURE_METHOD           = "SignatureMethod";

    # STRIPE
    const STRIPE_EVENT_ID              = "stripe_event_id";
    const STRIPE_EVENT_CREATED         = "stripe_event_created";
    const STRIPE_PAYMENT_INTENT_ID     = "stripe_payment_intent_id";
    const STRIPE_REFUND_STATUS         = "stripe_refund_status";
    const STRIPE_REFUND_FAILURE_REASON = "stripe_refund_failure_reason";

    # ROUTEE
    const RESPONSE_ROUTEE_CODE = "responseRouteeCode";

    # PAYPAL (most are uppercase)
    const ACK           = 'ACK';
    const ACTION        = 'action';
    const AMT           = 'AMT';
    const BUILD         = 'BUILD';
    const CORRELATIONID = 'CORRELATIONID';
    const DATA          = 'data';
    const DESC          = 'DESC';
    const DESCRIPTION   = 'description';
    const INVNUM        = 'INVNUM';
    const PAYPAL_LINK   = 'paypal_link';
    const PAYPAL_TOKEN  = 'PAYPAL_TOKEN';
    const VERSION       = 'VERSION';

    # AUTO-RECHARGE
    const APPLYING                   = 'applying';
    const PAYMENT_METHOD_SLUG        = 'payment_method_slug';
    const RECHARGE_AMOUNT            = 'recharge_amount';
    const RECHARGE_TRIGGER_ID        = 'recharge_trigger_id';
    const SECURITY_LIMIT             = 'security_limit';
    const TOTAL_AUTORECHARGES_AMOUNT = 'totalAutoRechargesAmount';

    ## JCC FIELDS
    const JCC_BILLING_ADDRESS      = "billAddress1";
    const JCC_BILLING_CITY         = "billCity";
    const JCC_BILLING_COUNTRY_CODE = "billCountry";
    const JCC_BILLING_EMAIL        = "billEmail";
    const JCC_BILLING_FIRSTNAME    = "billFirstName";
    const JCC_BILLING_LAST_NAME    = "billLastName";
    const JCC_BILLING_PHONE        = "billMobilePhone";
    const JCC_BILLING_POSTCODE     = "billPostalCode";

    # API GENERAL LOGGING FIELDS
    const DEVELOPER_MESSAGE = 'developerMessage';
    const METHOD            = 'method';
    const PATH              = 'path';
    const PAYLOAD           = 'payload';
    const HEADERS           = 'headers';
    const RESULT            = 'result';
    const START_DATE        = 'StartDate';
    const END_DATE          = 'EndDate';

    # FRESHSALES
    const ADDRESS              = 'address';
    const CITY                 = 'city';
    const COMPANY              = 'company';
    const CONTACT_EMAIL        = 'contact_email';
    const CONTACT_ID           = 'contact_id';
    const CONTACT_OWNER_EMAIL  = 'contact_owner_email';
    const CUSTOM_FIELD         = 'custom_field';
    const DEALDATA             = 'dealdata';
    const DEAL_ID              = 'deal_id';
    const FS_OWNER_ID          = 'fs_owner_id';
    const LEAD_EMAIL           = 'lead_email';
    const LEAD_ID              = 'lead_id';
    const LEAD_OWNER_EMAIL     = 'lead_owner_email';
    const MEDIUM               = 'medium';
    const MOBILE_NUMBER        = 'mobile_number';
    const TAGS                 = 'tags';
    const ZIPCODE              = 'zipcode';
    const FS_EXCEPTION_MESSAGE = 'fs_exception_message';
    const FS_PAYLOAD           = 'fs_payload';
    const FAILED_CRM_JOB_ID    = 'failed_crm_job_id';

    # FRESHDESK
    const FRESHDESK_COMPANY_ID = 'freshdesk_company_id';
    const FRESHDESK_CONTACT_ID = 'freshdesk_contact_id';
    const UNIQUE_EXTERNAL_ID   = 'unique_external_id';

    # MESSAGING / ESTIMATION
    const CONTACTS       = 'contacts';
    const DEFAULT_PREFIX = 'default_prefix';
    const ERROR          = 'error';
    const ESTIMATED_COST = 'estimatedCost';
    const FLASH_SMS      = 'flash_sms';
    const MESSAGE_SMSTO  = 'message_smsto';
    const MESSAGE_TYPE   = 'message_type';
    const NOSMS_DOMAIN   = 'nosms_domain';
    const NETWORK_ID     = 'network_id';
    const SENDER_ID      = 'sender_id';
    const SINGLE_CONTACT = 'single_contact';
    const SMS_COUNT      = 'smsCount';
    const TOTAL_MESSAGES = 'totalMessages';
    const USER_LISTS     = 'user_lists';

    # MAIL/SMS NOTIFICATIONS
    const FILENAME = "filename";

    # SENDY
    const SENDY_LIST_ID  = 'sendy_list_id';
    const SENDY_ACTION   = 'sendy_action';
    const SENDY_RESPONSE = 'sendy_response';
    const SENDY_SUCCESS  = 'sendy_success';

    # APOLLO.IO


    # SHORTLINKS
    const SHORTLINK_ID = 'shortlink_id';
    const URL          = 'url';

    # SUBSCRIPTIONS/INBOUND SMS
    const REASON          = 'reason';
    const SUBSCRIPTION_ID = 'subscription_id';

    # AFFILIATE
    const EMAILS_SENT    = "emails_sent";
    const SENDER_EMAIL   = "sender_email";
    const SENDER_USER_ID = "sender_user_id";

    # OPTOUT
    const URL_CODE = 'url_code';

    # ADMIN ACTIVITIES
    const ACTION_BY_CITY    = 'action_by_city';
    const ACTION_BY_COUNTRY = 'action_by_country';
    const ACTION_BY_EMAIL   = 'action_by_email';
    const ACTION_BY_IP      = 'action_by_ip';
    const ACTION_BY_USER_ID = 'action_by_user_id';
    const ACTION_TO_USER    = 'action_to_user';
    const EVENT             = 'event';

    # SUPERVISOR
    const QUEUE_ERROR  = 'queue_error';
    const QUEUE_NAME   = 'queue_name';
    const QUEUE_STATUS = 'queue_status';
    const TAG          = 'tag';

    # ERROR EXCEPTIONS:
    const EXCEPTION_MESSAGE    = 'exception_message';
    const EXCEPTION_TRACE      = 'exception_trace';
    const STRIPE_ERROR_CODE    = 'stripe_error_code';
    const STRIPE_ERROR_MESSAGE = 'stripe_error_message';
    const STRIPE_ERROR_DOC_URL = 'STRIPE_ERROR_DOC_URL';

    # SETTING FIELDS
    const USER_SETTING_BILLING_TYPE         = 'user_setting_billing_type';
    const USER_SETTING_CALLBACK_URL         = 'user_setting_callback_url';
    const USER_SETTING_DEFAULT_PREFIX       = 'user_setting_default_prefix';
    const USER_SETTING_DISABLE_TRANSCODE    = 'user_setting_disable_transcode';
    const USER_SETTING_FLASH_SMS            = 'user_setting_flash_sms';
    const USER_SETTING_MAXIMUM_SMS_PART     = 'user_setting_maximum_sms_parts';
    const USER_SETTING_RESTRICTED_COUNTRIES = 'user_setting_restricted_countries';
    const USER_SETTING_SENDER_ID            = 'user_setting_sender_id';
    const USER_METAS_ID                     = 'user_metas_id';

    # VALIDATION
    const FAILED_VALIDATION_ERRORS = 'validation_errors'; //@todo type string?
    const FAILED_VALIDATION_URL    = 'failed_validation_url';


    //because on code we have different variations of fields we need to map them to the actual end fields we want
    public static array $mapping_fields = [
        'authenticate_result' => self::AUTH_RESULT,
        'login_result'        => self::AUTH_RESULT,
        'refreshedToken'      => self::REFRESHED_TOKEN,
        'serviceName'         => self::SERVICE_NAME,
        'teamId'              => self::TEAM_ID,
        'userId'              => self::SMS_USER_ID,
        'user_Id'             => self::SMS_USER_ID,
        'user_id'             => self::SMS_USER_ID,
        'user_remote'         => self::AUTH_USER_ID,
        'user_remote_id'      => self::AUTH_USER_ID,
        'message_user_id'     => self::AUTH_USER_ID,
        'user_email'          => self::EMAIL,
        'TOKEN'               => self::PAYPAL_TOKEN,
        'orderID'             => self::ORDER_ID,
        'Version'             => self::VERSION,
        'vatAmount'           => self::VAT,
        'formattedTotal'      => self::FORMATTED_TOTAL,
        'cashBalance'         => self::BALANCE,
        'number'              => self::PHONE,
        'gatewayFeeAmount'    => self::GATEWAY_FEE,
        'organization_name'   => self::COMPANY,
    ];

    //add here only values that are integers
    protected static array $integer_fields = [
        self::ACQUIRER_ID,
        self::ACQ_ID,
        self::ACTION_BY_USER_ID,
        self::APPLYING,
        self::AUTH_USER_ID,
        self::AUTHENTICATION_ATTEMPTS,
        self::BUILD,
        self::CONTACT_ID,
        self::DEAL_ID,
        self::EMAILS_SENT,
        self::FRESHDESK_COMPANY_ID,
        self::FRESHDESK_CONTACT_ID,
        self::FS_OWNER_ID,
        self::JCC_BILLING_COUNTRY_CODE,
        self::LEAD_ID,
        self::MERCHANT_ID,
        self::MER_ID,
        self::NETWORK_ID,
        self::PAYMENT_ID,
        self::PAYMENT_METHOD_ID,
        self::PURCHASE_CURRENCY,
        self::PURCHASE_CURRENCY_EXPONENT,
        self::REASON_CODE,
        self::RECHARGE_TRIGGER_ID,
        self::RESPONSE_CODE,
        self::RESPONSE_ROUTEE_CODE,
        self::SENDER_USER_ID,
        self::SERVICE_ID,
        self::SHORTLINK_ID,
        self::SMS_COUNT,
        self::SMS_USER_ID,
        self::SUBSCRIPTION_ID,
        self::TEAM_ID,
        self::TOTAL_MESSAGES,
        self::UNIQUE_EXTERNAL_ID,
        self::USER_SETTING_DISABLE_TRANSCODE,
        self::USER_SETTING_MAXIMUM_SMS_PART,
        self::USER_METAS_ID,
        self::UPDATED_BY_AUTH_USER_ID,
    ];

    //add here only values that are float/doubles
    protected static array $float_fields = [
        self::AMOUNT,
        self::AMOUNT_IN_EUR,
        self::AMT,
        self::BALANCE,
        self::ESTIMATED_COST,
        self::FORMATTED_TOTAL,
        self::NEW_BALANCE,
        self::NEW_DB_BALANCE,
        self::OLD_BALANCE,
        self::OLD_BALANCE_BEFORE_CHANGE,
        self::OLD_BALANCE_AFTER_CHANGE,
        self::RECHARGE_AMOUNT,
        self::SECURITY_LIMIT,
        self::TOTAL,
        self::TOTAL_AUTORECHARGES_AMOUNT,
        self::VAT,
        self::VAT_IN_EUR,
        self::GATEWAY_FEE,
        self::GATEWAY_FEE_IN_EUR,
        self::REFUND_AMOUNT,
    ];

    //add here only values that are pure strings
    protected static array $string_fields = [
        self::A2_CODE,
        self::ACK,
        self::ACTION,
        self::ACTION_BY_CITY,
        self::ACTION_BY_COUNTRY,
        self::ACTION_BY_EMAIL,
        self::ACTION_BY_IP,
        self::ACTION_TO_USER,
        self::ADDRESS,
        self::API_KEY,
        self::AUTH_RESULT,
        self::AVATAR,
        self::BAN_REASON,
        self::BILLING_COUNTRY,
        self::BILLING_DETAILS,
        self::BUSINESS_ADDRESS,
        self::BUSINESS_CITY,
        self::BUSINESS_COUNTRY,
        self::BUSINESS_POSTAL_CODE,
        self::CALLBACK_URL,
        self::CAPTURE_FLAG,
        self::CITY,
        self::CLIENT_ID,
        self::COMPANY,
        self::CONTACTS,
        self::CONTACT_EMAIL,
        self::CONTACT_OWNER_EMAIL,
        self::CORRELATIONID,
        self::COUNTRY,
        self::COUNTRY_IP,
        self::CONFIRM_CODE,
        self::CUSTOM_FIELD,
        self::DATA,
        self::DEALDATA,
        self::DEFAULT_PREFIX,
        self::DESC,
        self::DESCRIPTION,
        self::DEVELOPER_MESSAGE,
        self::EMAIL,
        self::ERROR,
        self::EVENT,
        self::EXCEPTION_MESSAGE,
        self::EXCEPTION_TRACE,
        self::EXPECTED_SIGNATURE,
        self::FAILED_AT,
        self::FAIL_STATUS,
        self::FILENAME,
        self::FIRST_NAME,
        self::FLASH_SMS,
        self::FORM_PARAMS,
        self::HEADERS,
        self::INVNUM,
        self::IP_ADDRESS,
        self::JCC_BILLING_ADDRESS,
        self::JCC_BILLING_CITY,
        self::JCC_BILLING_EMAIL,
        self::JCC_BILLING_FIRSTNAME,
        self::JCC_BILLING_LAST_NAME,
        self::JCC_BILLING_PHONE,
        self::JCC_BILLING_POSTCODE,
        self::JWT_AUTH_SECRET,
        self::LAST_NAME,
        self::LIST_CONTACTS,
        self::LEAD_EMAIL,
        self::LEAD_OWNER_EMAIL,
        self::MEDIUM,
        self::MER_RESP_URL,
        self::MER_CALLBACK_URL,
        self::MESSAGE_SMSTO,
        self::MESSAGE_TYPE,
        self::METHOD,
        self::MOBILE_NUMBER,
        self::NAME,
        self::NOSMS_DOMAIN,
        self::ORDER_ID,
        self::PASSWORD,
        self::PATH,
        self::PAYLOAD,
        self::PAYMENT_METHOD,
        self::PAYMENT_METHOD_SLUG,
        self::PAYPAL_LINK,
        self::PHONE,
        self::PROFORMA_INVOICE_NUMBER,
        self::PURCHASE_AMT,
        self::QUEUE_ERROR,
        self::QUEUE_NAME,
        self::QUEUE_STATUS,
        self::REASON,
        self::REFRESHED_TOKEN,
        self::REGISTER_RESULT,
        self::REMARKS,
        self::REQUEST_IP,
        self::RESPONSE_DATA,
        self::RESPONSE_MESSAGE,
        self::RESPONSE_SIGNATURE,
        self::RESULT,
        self::SEARCH_KEYWORD,
        self::SECRET,
        self::SENDER_EMAIL,
        self::SENDER_ID,
        self::SENT_AT,
        self::SERVICE_NAME,
        self::SIGNATURE,
        self::SIGNATURE_METHOD,
        self::SIGNED_PAYLOAD,
        self::SINGLE_CONTACT,
        self::SITE,
        self::STATUS,
        self::TAG,
        self::TAGS,
        self::TITLE,
        self::TIMEZONE,
        self::TOKEN,
        self::UNVERIFIED_EMAIL,
        self::URL,
        self::URL_CODE,
        self::USERNAME,
        self::USER_LISTS,
        self::VERSION,
        self::ZIPCODE,
        self::RESTORE_HASH,
        self::REFUND_DATE,
        self::RULE,
        self::RULE_RESULT,
        self::USER_SETTING_BILLING_TYPE,
        self::USER_SETTING_DEFAULT_PREFIX,
        self::USER_SETTING_RESTRICTED_COUNTRIES,
        self::USER_SETTING_CALLBACK_URL,
        self::USER_SETTING_SENDER_ID,
        self::USER_SETTING_FLASH_SMS,
        self::START_DATE,
        self::END_DATE,
        self::INTERVAL,
        self::SENDY_LIST_ID,
        self::SENDY_ACTION,
        self::SENDY_RESPONSE,
        self::PARAMS,
        self::FAILED_VALIDATION_URL,
    ];

    protected static array $boolean_fields = [
        self::RESTRICTED_TO_OWN_NUMBER
    ];
}
